searchNodes=[{"type":"module","title":"BuildDotZig.Compiler","doc":"","ref":"BuildDotZig.Compiler.html"},{"type":"function","title":"BuildDotZig.Compiler.build/1","doc":"","ref":"BuildDotZig.Compiler.html#build/1"},{"type":"function","title":"BuildDotZig.Compiler.clean/0","doc":"","ref":"BuildDotZig.Compiler.html#clean/0"},{"type":"function","title":"BuildDotZig.Compiler.compile/0","doc":"","ref":"BuildDotZig.Compiler.html#compile/0"},{"type":"task","title":"Mix.Tasks.BuildDotZig.Gen.CNif","doc":"Initializes a C NIF with its build system based on build.zig . mix build_dot_zig . gen . c_nif Math math sum / 2 multiply / 2 The first argument is the Elixir module that will expose the NIF, relative to the base namespace of your app. In this case the generated module will be in lib/your_app/math.ex and will be called YourApp.Math . The second argument is the name of the NIF library. In this case the generated C file will be src/math.c . The other arguments represent the functions exposed by the NIF with their arity. Empty stubs for each of the listed functions will be generated both on the Elixir and C side. By default the function stubs just raise a :not_implemented error. Functions The functions are given using name/arity syntax. It's possible to pass the same function with multiple arities (e.g. sum/2 , sum/3 ), in that case on the C side there will still be only a single function and its implementation will have to distinguish between the different arities at runtime by looking at argc .","ref":"Mix.Tasks.BuildDotZig.Gen.CNif.html"},{"type":"task","title":"Mix.Tasks.Compile.BuildDotZig","doc":"Runs zig build using the build.zig file in the current project. This task runs zig build in the current project; any output coming from zig build is printed in real-time on stdout. Configuration This compiler can be configured through the return value of the project/0 function in mix.exs ; for example: def project ( ) do [ app : :myapp , install_zig : &quot;0.10.1&quot; , compilers : [ :build_dot_zig ] ++ Mix . compilers , deps : deps ( ) ] end The following options are available: :install_zig - (binary or boolean) determines if a Zig installation should be automatically downloaded and installed locally in the build directory. If false , no Zig installation is downloaded. If true (default), the latest Zig stable version is downloaded. Otherwise, it's possible to pass a specific Zig version, e.g. install_zig: &quot;0.11.0&quot; . Zig version support :build_dot_zig currently supports only Zig version 0.11.0 due to breaking changes to the build options passed in the command line. As long as the command line interface remains stable, it will be possible to support multiple future Zig versions. :zig_executable - (binary or :default ) it's the executable to use as the zig program. If not provided or if :default , it defaults to the downloaded zig binary if the install_zig was configured to download Zig, otherwise it defaults to zig (it assumes to find it in the PATH ). Note that it's possible to both install a downloaded Zig installation and pass a local :zig_executable . This is useful for use cases where the downloaded Zig installation must be called through some wrapper script. :zig_build_mode - (atom) allows choosing the build mode. The supported build modes are :debug , :release_safe , :release_fast and :release_small . By default the build mode is :release_safe when Mix.env() is :prod and :debug in all other cases. :zig_target - (binary or :host ) it's the target that will be passed with the -Dtarget flag to zig . This can be used to support cross-compilation. If not provided or if :host (which is the default returned by Mix.target() ), the -Dtarget flag is not passed. :zig_cpu - (binary or :native ) the set of CPU features that will be passed with the -Dcpu flag to zig . If not provided or if :native the -Dcpu flag is not passed, which makes zig use all the CPU features of the host. If you're not running the compiled code on the same machine where you're compiling, setting this to &quot;baseline&quot; is a good starting point. :zig_extra_options - (keyword list) if you define additional options in your build.zig using b.option() , you can pass the values of those options here (e.g. [some_option: &quot;some_value&quot;] ). Default environment variables This compiler also sets deveral default environment variables which are accessible from build.zig : MIX_TARGET MIX_ENV MIX_BUILD_PATH - same as Mix.Project.build_path/0 MIX_APP_PATH - same as Mix.Project.app_path/0 MIX_COMPILE_PATH - same as Mix.Project.compile_path/0 MIX_CONSOLIDATION_PATH - same as Mix.Project.consolidation_path/0 MIX_DEPS_PATH - same as Mix.Project.deps_path/0 MIX_MANIFEST_PATH - same as Mix.Project.manifest_path/0 ERL_EI_LIBDIR ERL_EI_INCLUDE_DIR ERTS_INCLUDE_DIR ERL_INTERFACE_LIB_DIR ERL_INTERFACE_INCLUDE_DIR ZIG_INSTALL_DIR - the directory where the Zig toolchain was downloaded, if it was. Compilation artifacts and working with priv directories Generally speaking, compilation artifacts are written to the priv directory, as that the only directory, besides ebin , which are available to Erlang/OTP applications. However, note that Mix projects supports the :build_embedded configuration, which controls if assets in the _build directory are symlinked (when false , the default) or copied ( true ). In order to support both options for :build_embedded , it is important to follow the given guidelines: The &quot;priv&quot; directory must not exist in the source code If there are static assets, build.zig should copy them over from a directory at the project root (not named &quot;priv&quot;) This compiler passes $MIX_APP_PATH/priv/$MIX_TARGET as install prefix to zig build , so the resulting artifacts can be found in $PREFIX/lib for libraries and $PREFIX/bin for binaries. Note that the default $MIX_TARGET is :host .","ref":"Mix.Tasks.Compile.BuildDotZig.html"},{"type":"extras","title":"Changelog","doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html"},{"type":"extras","title":"Changelog - [0.4.0] - 2023-12-11","doc":"Added Add mix build_dot_zig.gen.c_nif Mix generator. Allow passing project-specific options with zig_extra_options . Changed Use :release_safe build mode by default in :prod env. Leave :debug as default in all other cases. Fixed Fix arch detection on Windows.","ref":"changelog.html#0-4-0-2023-12-11"},{"type":"extras","title":"Changelog - [0.3.1] - 2023-08-22","doc":"Fixed Pass the correct option for optimize modes. Changed Due to the different options for the optimize modes, :build_dot_zig is currently only compatible with Zig version 0.11.0 .","ref":"changelog.html#0-3-1-2023-08-22"},{"type":"extras","title":"Changelog - [0.3.0] - 2023-08-08","doc":"Added Add zig_target option. Add zig_cpu option. Changed Bump latest stable zig to 0.11.0 .","ref":"changelog.html#0-3-0-2023-08-08"},{"type":"extras","title":"Changelog - [0.2.0] - 2023-07-10","doc":"Added Clean Zig cache on mix.clean . Add functionality to automatically download the zig toolchain, also with a specific version. Allow defining the build mode from the Mix configuration. Changed BREAKING: rename :build_dot_zig_executable option to :zig_executable .","ref":"changelog.html#0-2-0-2023-07-10"},{"type":"extras","title":"Changelog - [0.1.1] - 2023-03-03","doc":"Fixed Handle :default in the :build_dot_zig_executable option. Changed Put zig-cache in the _build folder with all other build artifacts.","ref":"changelog.html#0-1-1-2023-03-03"},{"type":"extras","title":"Changelog - [0.1.0] - 2023-02-26","doc":"Added Initial release.","ref":"changelog.html#0-1-0-2023-02-26"}]